<?php
namespace Ecomerciar\CruzDelSur\Block\Widget;

use Magento\Framework\View\Element\Template;
use Magento\Widget\Block\BlockInterface;

class TrackingForm extends Template implements BlockInterface
{
    protected $_template = "widget/TrackingForm.phtml";
    /**
     * @param \Magento\Backend\Block\Widget\Context $context
     * @param \Magento\Framework\Data\Form\FormKey $formKey
     * @param array $data
     */
    public function __construct(
        \Magento\Backend\Block\Widget\Context $context,
        \Magento\Framework\Data\Form\FormKey $formKey,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->formKey = $formKey;
    }

    /**
     * Gets Form key
     *
     * @return string
     */
    public function getFormKey()
    {
        return $this->formKey->getFormKey();
    }

    /**
     * Gets URL for Form
     *
     * @return string
     */
    public function getFormActionUrl()
    {
        return $this->getUrl('cruzdelsurajax/widget/track');
    }
}
